import { Player, system, world } from '@minecraft/server';


world.afterEvents.itemUseOn.subscribe(eventData => {
    const player = eventData.source;
    const itemStack = eventData.itemStack;

    smartStackSearch(player,itemStack)
})


world.afterEvents.itemCompleteUse.subscribe(eventData => {
    const player = eventData.source;
    const itemStack = eventData.itemStack;

    smartStackSearch(player,itemStack)
})

world.afterEvents.itemUse.subscribe(eventData => {
    const player = eventData.source;
    const itemStack = eventData.itemStack;

    smartStackSearch(player,itemStack)
})

world.afterEvents.playerBreakBlock.subscribe(eventData => {
    const player = eventData.player
    const itemStack = eventData.itemStackBeforeBreak;

    smartStackSearch(player,itemStack)

})

export function smartStackSearch(player,itemStack){
    if (itemStack && itemStack.amount - 1 == 0){
        const inventory = player.getComponent('inventory').container;
        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item && item.typeId == itemStack.typeId){
                inventory.swapItems(i,player.selectedSlotIndex,inventory)
                return
            }
        }
    }
}

